MOSYSDIR ?= ../..
ROSCODIR ?= $(MOSYSDIR)/../../..
SYSDIR ?= $(ROSCODIR)/code/software/libs/build
SYSINCDIR ?= ${SYSDIR}/include
SYSLIBDIR ?= ${SYSDIR}/lib
USERDIR ?= $(MOSYSDIR)/user
LIBMOSYSDIR ?= $(USERDIR)/libmosys

TARGET ?= libmosys.a
OBJS := \
	crt0.o														\
	assert/__assert_fail.o										\
	err/err.o													\
	errno/_errno.o												\
	fcntl/open.o												\
	sched/clone.o												\
	spawn/posix_spawn.o											\
	stdlib/_exit.o stdlib/exit.o								\
	sys/wait/wait.o	sys/ioctl/ioctl.o							\
	time/nanosleep.o											\
	unistd/close.o unistd/getpid.o unistd/read.o unistd/write.o	\
	unistd/syscall.o unistd/sleep.o	unistd/execve.o				\
	unistd/_exit.o												\
	__internal/__progname.o

DEFINES = -DROSCO_M68K

CFLAGS = \
	-std=gnu11 -ffreestanding -Wall -pedantic -Werror			\
	-isystem $(LIBMOSYSDIR) -isystem $(SYSINCDIR)				\
	-mcpu=68010 -march=68010 -mtune=68010						\
	-mno-align-int -mno-strict-align $(DEFINES) -O2 -MD -MP

ASFLAGS = -Felf -m68010 -quiet $(DEFINES) -dependall=make -depfile $(@:.o=.d)

ARFLAGS =

CC = m68k-elf-gcc
LD = m68k-elf-ld
AR = m68k-elf-ar
RANLIB=m68k-elf-ranlib
AS=vasmm68k_mot
RM_F=rm -f
RM_RF=$(RM_F) -r
MKDIR_P=mkdir -p
CP_R=cp -r

DEPS := $(OBJS:.o=.d)

$(TARGET): $(OBJS)
	$(AR) $(ARFLAGS) rs $@ $^
	$(AR) $(ARFLAGS) rs $@ $^
	$(RANLIB) $@

.PHONY: all clean

all: $(TARGET)

clean: 
	$(RM_F) $(OBJS) $(DEPS) $(TARGET)

-include $(DEPS)
